#include <stdlib.h>
#include "list.H"

LISTElement::LISTElement(void *itemPtr, int sortKey)
{
     item = itemPtr;
     key = sortKey;
     next = NULL;
}

LIST::LIST()
{ 
    first = last = NULL; 
}

LIST::~LIST()
{ 
    while (Remove(NULL) != NULL);
}

bool LIST::IsEmpty() 
{ 
    if (first == NULL)
        return true;
    else return false;
}


void LIST::Insert(void *item, int sortKey)
{
    LISTElement *element = new LISTElement(item, sortKey);
    LISTElement *ptr;

	if (IsEmpty()) {
        first = element;
        last = element;
    } else if (sortKey < first->key) {	
	element->next = first;
	first = element;
    } else {
        for (ptr = first; ptr->next != NULL; ptr = ptr->next) {
            if (sortKey < ptr->next->key) {
		element->next = ptr->next;
	        ptr->next = element;
		return;
	    }
	}
	last->next = element;
	last = element;
    }
}

void *LIST::Remove(int *keyPtr)
{
    LISTElement *element = first;
    void *thing;

    if (IsEmpty()) 
	return NULL;

    thing = first->item;
    if (first == last) {
        first = NULL;
	last = NULL;
    } else {
        first = element->next;
    }
    if (keyPtr != NULL)
        *keyPtr = element->key;
    delete element;
    return thing;
}
