#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <mpi.h>
#include "log.H"

bool LOG_DEBUG_REPORTED=false,
    LOG_FATAL_REPORTED=true;

void SetDebugReported(bool flag) {
    LOG_DEBUG_REPORTED=flag;
}

void _debug(const char *fmt, ...) {

    if (LOG_DEBUG_REPORTED) {
	va_list arg;
	char buf[1024];

	snprintf(buf, sizeof buf, "DEBUG: %s", fmt);

	va_start(arg, fmt);
	vfprintf(stderr, buf, arg);
	va_end(arg);

	fflush(stderr);
    }
}

void SetFatalReported(bool flag) {
    LOG_FATAL_REPORTED=flag;
}

void _fatal(const char *fmt, ...) {
    if (LOG_FATAL_REPORTED) {
	va_list arg;
	char buf[1024];

	snprintf(buf, sizeof buf, "FATAL: %s", fmt);

	va_start(arg, fmt);
	vfprintf(stderr, buf, arg);
	va_end(arg);

	fflush(stderr);
    }

    MPI_Finalize();

    exit(1);
}
